#include <bits/stdc++.h>

using namespace std;

int main()
{
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,q;
    cin >> n >> q;
    string s;
    cin >> s;
    string t = "";
    for(int i = 0; i < n; i++)
    {
        t += '?';
    }
    if(s == t)
    {
        vector<int> v(0);
        for(int i = 0; i < q; i++)
        {
            int a,b;
            cin >> a >> b;
            int pro = -1;
            for(int i = 0; i < b-a+1; i++){
                if(i*(b-a+1-i) > pro){
                    pro = i*(b-a+1-i);
                }
            }
            v.push_back(pro);
        }
        for(int x : v)
        {
            cout << x << endl;
        }
    }
}